
DOSSEG
.MODEL SMALL
.STACK 200h
.286
	CON_COL	EQU 50H

	ASSUME CS:DGROUP , DS:DGROUP
	DGROUP GROUP CODE_SEG
	DGROUP GROUP BITMAP
	DGROUP GROUP LOCALDATA
	DGROUP GROUP DATA_SEGS

	INCLUDE DATA.DAT


CODE_SEG SEGMENT 'CODE'

	NL EQU 13,10
	EL EQU 0
;
PRINTF MACRO  MSG__:VARARG
LOCAL   NAME__
	DATA_SEGS SEGMENT WORD PUBLIC 'DATA'
	  NAME__ LABEL BYTE
	  DB MSG__
	DATA_SEGS ENDS
	INVOKE TOCON, OFFSET DGROUP:NAME__
ENDM
;
	INCLUDE DOS2BIOS.H
;


OUTXY   PROTO  C X:BYTE , Y:BYTE , MSG__:WORD
PUTXY   PROTO  C X:BYTE , Y:BYTE , CHAR:BYTE , ATTR:BYTE
WINDOW  PROTO C X1:BYTE , Y1:BYTE , X2:BYTE , Y2:BYTE
WIN_CLS PROTO C
TOCON   PROTO C MSG__:WORD
PUTCHAR PROTO C CHAR:BYTE


OUTXY PROC C X:BYTE , Y:BYTE , MSG__:WORD
	PUSHA
	MOV SI,MSG__
	MOV CL,X
	 .WHILE ( BYTE PTR [SI] != 0 )
	    INVOKE PUTXY , CL , Y , BYTE PTR [SI],0
	    INC SI
	    INC CL
	 .ENDW
	POPA
	RET
OUTXY ENDP

PUTXY PROC C X:BYTE , Y:BYTE , CHAR:BYTE , ATTR:BYTE
	PUSHA

	MOV BX,0B800H
	MOV ES,BX
	
	MOV AX,160
	XOR BX,BX
	MOV BL,Y
	MUL BL
	MOV BL,X
	SHL BX,1
	ADD BX,AX
	MOV AH,ATTR
	MOV AL,CHAR
	.IF  AH!=0
		MOV ES:[BX],AX
	.ELSE
		MOV ES:[BX],AL
	.ENDIF
	POPA
	RET
PUTXY ENDP


WINDOW PROC C X1:BYTE , Y1:BYTE , X2:BYTE , Y2:BYTE
	PUSH AX
	PUSH BX
	MOV AH,X1
	MOV AL,X2
	MOV BH,Y1
	MOV BL,Y2
	MOV LEFT,AH
	MOV TOP,BH
	MOV RIGHT,AL
	MOV BOTTOM,BL
	MOV ROW,BH
	MOV COL,AH
	POP BX
	POP AX
	RET
WINDOW ENDP

WIN_CLS PROC C
    PUSHA

    MOV AH,TOP
    MOV AL,LEFT
    MOV ROW,AH
    MOV COL,AL
    MOV CL,BOTTOM
    INC CL
    SUB CL,TOP

     MOV AH,6
     MOV AL,CL
     MOV BH,CON_COL
     MOV CH,TOP
     MOV CL,LEFT
     MOV DH,BOTTOM
     MOV DL,RIGHT	
     INT 10H
     MOV AH,TOP
     MOV AL,LEFT
     MOV ROW,AH
     MOV COL,AL
     
     POPA
     RET
WIN_CLS ENDP

TOCON PROC C MSG__:WORD
      PUSHA
      MOV SI,MSG__
      .WHILE (BYTE PTR [SI] != 0)
	INVOKE PUTCHAR , BYTE PTR [SI]
	INC SI
      .ENDW
     POPA
     RET
TOCON ENDP

PUTCHAR PROC C CHAR:BYTE
  PUSHA
  MOV AH,ROW
  MOV AL,COL
  .IF  CHAR==10
     .IF AH < BOTTOM
	INC ROW
	POPA
	RET
     .ENDIF
     MOV AH,6
     MOV AL,1
     MOV BH,CON_COL
     MOV CH,TOP
     MOV CL,LEFT
     MOV DH,BOTTOM
     MOV DL,RIGHT
     INT 10H
     POPA
     RET
  .ELSEIF CHAR==13
     MOV AH,LEFT
     MOV COL,AH
     POPA
     RET
  .ELSEIF AL > RIGHT
     INVOKE PUTCHAR , 10
     MOV AH,LEFT
     MOV COL,AH
  .ENDIF

  MOV AX,0B800H
  MOV ES,AX
  XOR BX,BX
  MOV AX,160
  MOV BL,ROW
  MUL BL
  MOV BL,COL
  SHL BX,1
  ADD BX,AX
  MOV AL,CHAR
  MOV ES:[BX],AL
  INC COL
  POPA
  RET	
PUTCHAR ENDP



MEDIA_TYPE PROC
	MOV AL,L_MEDIA
	INC AL
	CMP AL,3
	JB MED00
	XOR AL,AL
MED00:  MOV L_MEDIA,AL
	.IF       AL==0
	  	     INVOKE OUTXY, 44 , 5 , OFFSET RAW_M
	.ELSEIF   AL==1
	  	     INVOKE OUTXY, 44 , 5 , OFFSET FISA_M
	.ELSEIF   AL==2
	  	     INVOKE OUTXY, 44 , 5 , OFFSET DOS_M
	.ENDIF
	RET
MEDIA_TYPE ENDP

DISK_TYPE PROC
	MOV AL,SPACE1
	INC AL
	CMP AL,3
	JB SPD00
	XOR AL,AL
SPD00:  MOV SPACE1,AL
	.IF       AL==0
	  	     INVOKE OUTXY, 44 , 4 , OFFSET D720
	.ELSEIF   AL==1
	  	     INVOKE OUTXY, 44 , 4 , OFFSET D120
	.ELSEIF   AL==2
	  	     INVOKE OUTXY, 44 , 4 , OFFSET D144
	.ENDIF
	RET
DISK_TYPE ENDP

PHYS_DRV PROC
	MOV AL,PH_DISK
	INC AL
	CMP AL,2
	JB PHY00
	XOR AL,AL
PHY00:	MOV PH_DISK,AL
	MOV CL,AL
	ADD CL,'A'
	INVOKE PUTXY, 44 ,3 , CL ,0
	RET
PHYS_DRV ENDP



HELP PROC C 
	 PUSHA
  	 MOV AH,6
	 MOV AL,2
	 MOV BH,CON_COL
	 MOV CH,16
         MOV CL,55
         MOV DH,17
         MOV DL,72
         INT 10H

	 CALL WIN_CLS
	 PRINTF NL,' * Options Toggle By Pressing Letter',EL
	 PRINTF NL,' * Select Physical Drive Lettre (not logical)',EL
	 PRINTF NL,' * Select Format Type 720KB, 1.2MB, 1.44MB',EL
	 PRINTF NL,' * Select Logical Format Type Raw, Fisa, Dos',EL
	 PRINTF NL,'  Raw  := No Logical Structure ( Low Format )',EL
	 PRINTF NL,'  Dos  := Write  Boot, Root and FAT',EL
	 PRINTF NL,'  Fisa := Mapped Boot, Root and FAT',EL
	 PRINTF NL,NL,'       Press Escape to Exit ',EL
	 PRINTF    NL,'       Press Enter To Go    ',EL
	 POPA
	 RET
HELP ENDP


OUT_INT PROC C X:BYTE , Y:BYTE , CHAR:BYTE
	PUSHA
	XOR AX,AX
	MOV AL,CHAR
	AAM	
	OR AX,3030H
	MOV BX,AX
	INVOKE PUTXY , X , Y   , BH, 0
	MOV BH,X
	INC BH
	INVOKE PUTXY , BH , Y , BL,0
	POPA
	RET
OUT_INT ENDP

SECT_STAT PROC C  MAP__:WORD
	PUSHA
	MOV SI,MAP__
	XOR CX,CX
	MOV CL,SECT_TRK
	SHR CX,1	
	XOR BX,BX

SQ1:	PUSH BX
	ADD  BL,55
	.IF BYTE PTR [SI] == 0
	      INVOKE PUTXY , BL , 16 , 251,1EH
	.ELSE 	      
	      INVOKE PUTXY , BL , 16 , 'E',4EH
	.ENDIF
	INC SI
	POP BX
	INC BX
	INC BX
	LOOP SQ1


	XOR CX,CX
	MOV CL,SECT_TRK
	SHR CX,1	
	JNC S_EVN
	INC CX
S_EVN:	XOR BX,BX
	
SQ2:	PUSH BX
	ADD  BL,55
	.IF BYTE PTR [SI] == 0
	      INVOKE PUTXY , BL , 17 , 251,1EH
	.ELSE 	      
	      INVOKE PUTXY , BL , 17 , 'E',4EH
	.ENDIF
	POP BX
	INC BX
	INC BX
	INC SI
	LOOP SQ2
	POPA
	RET
SECT_STAT ENDP

INCLUDE COL.INC
EXTRN LAYOUT:BYTE

LOADSCR PROC
	mov ax,3
	INT 10H
	CALL LOAD_CHAR
	PUSH DS
	MOV SI,SEG LAYOUT
	MOV DS,SI
	LEA SI,LAYOUT
	MOV CX,4000
LSCR:	PUSH CX
	XOR BYTE PTR [SI],055H
	INC SI
	POP CX
	LOOP LSCR
	LEA SI,LAYOUT
	XOR DI,DI
	MOV CX,4000
	CLD
	MOV AX,0B800H
	MOV ES,AX
	REP MOVSB
	POP DS 
	INVOKE WINDOW ,4,7,50,18
	CALL WIN_CLS
	RET
LOADSCR ENDP


	

; FORMAT 80 TRACKS 
FORMAT PROC

	MOV CUR_TRK,0

	MOV AX,351EH
	INT 21H
	PUSH WORD PTR ES:[BX+4]
	PUSH WORD PTR ES:[BX+6]
	POP  WORD PTR OLD_1E_INFO+2
	POP  WORD PTR OLD_1E_INFO+0
	MOV DI,BX

	XOR BX,BX
	MOV BL,SPACE1
	MOV CL,[BX+SPACE_TYPE+0]
	MOV CH,[BX+SPACE_TYPE+3]
	MOV SECT_TRK,CL
	MOV ES:[DI+4],CL		; SETTING SECTOR PER FAT
	MOV ES:[DI+7],CH		; SETTING GAP LENGTH

	MOV AH,0		; Reset The Drive
	MOV DL,PH_DISK		; Physical drive
	INT 13H

;	XOR AX,AX
;	XOR CX,CX
;	LEA SI,ADR_FIELD+2	; POINT TO SECTOR NUMBER
;	MOV CL,SECT_TRK
;	SHR CL,1
;	JNC  M_EVEN
;	INC CL
;M_EVEN:	MOV AL,CL
;M_M_M:	
;	INC AH
;	MOV [SI],AH
;	ADD SI,4
;	INC AL
;	MOV [SI],AL
;	ADD SI,4
;	LOOP M_M_M 


	MOV AX,4A10H			; FLUSH DISK CACHE
	MOV BX,1			; SERVICE NUMBER
	INT 2FH

	MOV AX,4A10H			; GET CAHCE INFORMATION ABOUT DRIVE
	MOV BX,3
	MOV DL,PH_DISK
	XOR DH,DH
	MOV BP,DX
	MOV DL,0
	INT 2FH
	MOV CACHE_STATUS,DL		; SAVE STATUS

	MOV AX,4A10H
	MOV BX,3
	MOV DL,PH_DISK
	XOR DH,DH
	MOV BP,DX
	MOV DL,2			; TURN READ CACHE OFF
	INT 2FH

	MOV AX,4A10H
	MOV BX,3
	MOV DL,PH_DISK
	XOR DH,DH
	MOV BP,DX
	MOV DL,4			; TURN WRITE CACHE OFF
	INT 2FH

	MOV AH,0		; Reset The Drive
	MOV DL,PH_DISK		; Physical drive
	INT 13H


DO1:
	MOV AH,1
	INT 16H
	JZ  NO_KEY
	MOV AH,0
	INT 16H
	CMP AH,1
	JNZ NO_KEY
	PRINTF NL,NL,' User Break ! ',EL
	STC
	JMP DO3
NO_KEY:	INVOKE OUT_INT , 55 , 7 , CUR_TRK
	CALL	FMT_TRK
	JC 	DO3
	INC	CUR_TRK
	CMP	CUR_TRK,80
	JB	DO1
	CLC

DO3:    PUSHF
	
	MOV DL,CACHE_STATUS
	AND DL,10000000B
	CMP DL,10000000B
	JNZ RCHE1
	MOV DL,PH_DISK
	XOR DH,DH
	MOV BP,DX
	MOV DL,1			; TURN READ CACHE ON
	MOV AX,4A10H
	MOV BX,3
	INT 2FH

RCHE1:	MOV DL,CACHE_STATUS
	AND DL,01000000B
	CMP DL,01000000B
	JNZ RCHE2
	MOV DL,PH_DISK
	XOR DH,DH
	MOV BP,DX
	MOV DL,3			; TURN WRITE CACHE ON
	MOV AX,4A10H
	MOV BX,3
	INT 2FH

RCHE2:
	MOV AX,351EH
	INT 21H
	
	PUSH WORD PTR OLD_1E_INFO+0
	PUSH WORD PTR OLD_1E_INFO+2
	POP  WORD PTR ES:[BX+6]
	POP  WORD PTR ES:[BX+4]


	MOV AH,0		; Reset The Drive
	MOV DL,PH_DISK		; Physical drive
	INT 13H

	POPF
	RET
FORMAT ENDP

; FOTMAT SINGLE TRACK 
FMT_TRK PROC

	MOV AL,CUR_TRK
	MOV AH,0

FD_A:	MOV DH,AH
	MOV RTY1,3

	MOV CX,18
	LEA BX,ADR_FIELD
FD_B:	MOV [BX],AX
	ADD BX,4
	LOOP FD_B

	INVOKE OUT_INT ,70,7,BYTE PTR ADR_FIELD+1
FD_C:
	PUSH DS
	POP  ES
	MOV AX,ADR_FIELD
	MOV DH,AH
	LEA BX,ADR_FIELD
	MOV DL,PH_DISK
	MOV CH,CUR_TRK
	MOV AL,SECT_TRK
	MOV AH,5
	INT 13H
	JNC  FD_D
	PUSH AX
	MOV AH,0		; Reset The Drive
	MOV DL,PH_DISK		; Physical drive
	INT 13H
	POP AX
	CMP AH,3
	JNZ FT1
	  PRINTF  NL, 'WRITE PROTECT ERROR. REMOVE THE NOTCH ',EL
	  PRINTF  NL, ' AND PRESS ANY KEY .',NL,EL
	  JMP FT2
FT1:	CMP AH,80H
	JNZ FT3
	  PRINTF NL,'DRIVE NOT READY.  PRESS ANY KEY',NL,EL
FT2:	  MOV AH,0
	  INT 16H
	  CMP AH,1
	  JNZ FT9
	  STC
	  RET

FT3:    DEC RTY1
FT9:	CMP RTY1,0
	JNZ FD_C
	STC

FD_D:   PUSHF
	INVOKE OUT_INT , 55, 12, BYTE PTR ADR_FIELD+0
	INVOKE OUT_INT , 70, 12, BYTE PTR ADR_FIELD+1
	PUSH DS
	POP ES
	POPF
	JNC FD_2


whole_trk_bad:
	
	MOV BX,OFF_BMP
	XOR CX,CX
	MOV CL,SECT_TRK
FD_V:	MOV BYTE PTR [BX],2
	INC BX
	LOOP FD_V
	XOR BX,BX
	MOV BL,SECT_TRK	
	ADD OFF_BMP,BX
	JMP FD_K


FD_2:	MOV AH,4
	MOV AL,SECT_TRK
	MOV CH,CUR_TRK
	MOV CL,1
	MOV DX,ADR_FIELD
	MOV DL,PH_DISK
	INT 13H
	JC  whole_trk_bad				; FD_F
	CMP AL,SECT_TRK
	JNZ whole_trk_bad				; FD_F
	MOV AH,0

	MOV BX,OFF_BMP
	XOR CX,CX
	MOV CL,SECT_TRK
FD_E:	MOV BYTE PTR [BX],0
	INC BX
	LOOP FD_E
	XOR BX,BX
	MOV BL,SECT_TRK	
	ADD OFF_BMP,BX
	JMP FD_K

FD_F:	MOV CX,1
	MOV BX,OFF_BMP

FD_G:	PUSH BX
	PUSH CX

	MOV AH,4
	MOV AL,1
	MOV CH,CUR_TRK
	MOV DX,ADR_FIELD
	MOV DL,PH_DISK
	INT 13H
	JC FD_I
	CMP AL,1
	JZ FD_J
FD_I:	MOV AH,2

FD_J:	POP CX
	POP BX	
	MOV [BX],AH
	INC BX
	INC CX
	CMP CL,SECT_TRK
	JBE FD_G
	MOV OFF_BMP,BX		


FD_K:	MOV BX,OFF_BMP
	SUB BX,18
	INVOKE SECT_STAT , BX


	MOV AX,ADR_FIELD
	INC AH
	CMP AH,1
	JNZ FD_Z
	JMP FD_A
FD_Z:	CLC
	RET
FMT_TRK ENDP

DUMMY_ISR:	IRET

; PROGRAM ENTRY POINT 
MAIN PROC

	PUSH CS
	POP DS
	LEA DX,DUMMY_ISR
	MOV AX,2523H
	INT 21H
	LEA DX,DUMMY_ISR
	MOV AX,2524H
	INT 21H



	PUSH CS
	PUSH CS
	POP DS
	POP ES

	CALL LOADSCR
	CALL MEDIA_TYPE
	CALL DISK_TYPE
	CALL PHYS_DRV

AGAIN:
	PUSH CS
	POP DS
	CALL HELP



	PUSH CS
	POP ES


	LEA DI,BMP
	MOV CX,3000
	CLD
	MOV AL,0
	REP STOSB							

M0:	MOV AH,0
	INT 16H
	CMP AH,1
	JNZ OP1
	MOV AX,3
	INT 10H
	MOV AH,4CH
	INT 21H

OP1:	CMP AH,32H			; CODE 'M'
	JNZ OP2
	  CALL MEDIA_TYPE
	  JMP M0
OP2:	CMP AH,20H			; CODE 'D'
	JNZ OP3
	  CALL DISK_TYPE
	  JMP M0
OP3:	CMP AH,19H			; CODE 'P'
	JNZ OP4
	  CALL PHYS_DRV
	  JMP M0
OP4:	CMP AH,1CH
	JNZ  M0
	PRINTF NL,NL,'      NOW FORMATTING.......',EL
	CALL FORMAT
	JNC M1
	PRINTF NL,NL,'      press any key ',EL
	MOV AH,0
	INT 16H
	JMP AGAIN
M2:	
	MOV AH,0
	INT 16H
	MOV AX,3
	INT 10H
	MOV AH,4CH
	INT 21H

	
M1:	PUSH CS
	POP  DS
	.IF     L_MEDIA == 0	
		     PRINTF NL,' RAW FORMAT. (no logical structure) ',EL
	.ELSEIF L_MEDIA == 1 
		     CALL FISA_FORMAT
	.ELSEIF L_MEDIA == 2
		     CALL DOS_FORMAT
	.ENDIF
	PUSH CS
	POP DS
	PRINTF NL,NL,'    press any key  ',EL
	MOV AH,8
	INT 21H
	JMP AGAIN
	
MAIN ENDP

;	
;	۱۱ CALL INT 13 WITH RETRY IF THERE IS A ERROR ۱۱
;	

BIOS13 PROC
	MOV CS:R13_,3
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
	
B13A:	POP DX
	POP CX
	POP BX
	POP AX
	
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
	
	INT 13H
	JNC B13_OK
	MOV DL,CS:PH_DISK
	XOR AX,AX
	INT 13H
	DEC CS:R13_
	CMP CS:R13_,0
	JNZ B13A
	PUSHA
	PRINTF NL,' Error in Writing System Information.',EL
	PRINTF NL,' You Should Have To ReFormat The Disk.',EL
	POPA
	CLI
	MOV AX,WORD PTR OLD_STACK+2
	MOV SP,WORD PTR OLD_STACK+0
	MOV SS,AX
	RET

B13_OK:	
	ADD SP,(2*4)
	CLC
	RET

BIOS13 ENDP


; FISA LOGICAL DISK FORMAT 
FISA_FORMAT PROC 

	MOV WORD PTR OLD_STACK+0,SP
	MOV WORD PTR OLD_STACK+2,SS


	PUSH CS
	PUSH CS
	POP  DS
	POP  ES
				; PREPEARING DUMMY FLOPPY FOR DOS
	MOV D_RATIO,	1
	MOV D_NBOOT,	1
	MOV D_NFAT,	1
	MOV D_DIRS,	16
	MOV D_NSECT,	8
	MOV D_MEDIA,	0FCH
	MOV D_S_FAT,	1
	;MOV D_S_TRK, 	9
	MOV D_HEAD,	2

	LEA DI,TBUFF
	MOV CX,4900
	CLD
	MOV AL,0
	REP STOSB							

	MOV BYTE PTR TBUFF+0,0FCH	; PREAPERING FAT
	MOV WORD PTR TBUFF+1,0FFFFH
	LEA BX,TBUFF
	MOV CX,2
	XOR DX,DX
	MOV AL,PH_DISK
	MOV AX,0302H
	CALL BIOS13
		

	.IF     SPACE1 == 0
	    MOV D_S_TRK ,9
	    MOV DIRS    ,112 
	    MOV NSECT   ,1440  +  18  		; TOTAL + SYSTEM AREA
	    MOV S_FAT	,5			; SECTORS CONSUMED BY SYSTEM
	    MOV S_TRK	,9			; WIIL BE SUBTRACTED
	    MOV AX,(20*2)			; FROM THIS NUMBER , RESULT
	    MOV BX,(11*2)			; IS ACTUALL SECTORS
	    MOV CX,(18*2)			; FOR OS
	.ELSEIF SPACE1 == 1
	    MOV D_S_TRK ,15
	    MOV DIRS    ,224 
	    MOV NSECT   ,2400  +  29 
	    MOV S_FAT	,7
	    MOV S_TRK	,15
	    MOV AX,(31*2)			; # SECTOR TO MAP * 2
	    MOV BX,(15*2)			; 1ST ROOT SECTOR AT
	    MOV CX,(29*2)			; 1ST DATA SECTOR AT
	.ELSE 
	    MOV D_S_TRK ,18
	    MOV DIRS    ,224 
	    MOV NSECT   ,2880  +  33 
	    MOV S_FAT	,9
	    MOV S_TRK	,18
	    MOV AX,(35*2)
	    MOV BX,(19*2)
	    MOV CX,(33*2)
	.ENDIF


	MOV SI,9			; INDEX TO SECTOR BYTE MAP
	MOV DI,OFFSET SECTMAP		; INDEX INTO SYSTEM SECTOR WORD MAP
	ADD AX,DI			; AX= ENDING ADDRESS OF WORD MAP
	ADD BX,DI			; BX= ADRESS OF 1ST ROOT SECTOR
	ADD CX,DI			; CX= ADRESS OF 1ST DATA SECTOR
	MOV RO_T,BX
	MOV DA_T,CX
	
	
K2:	CMP BYTE PTR [BMP+SI],0		; IS SECTOR IS GOOD
	JZ K3
	INC SI				; NO CHECHK NEXT
	JMP K2
K3:	MOV [DI],SI			; WRITE SECTOR # IN SYSTEM WORD MAP
	INC SI				; CHECK NEXT
	INC DI				; NEXT SYSTEM SECTOR
	INC DI
	CMP DI,AX			; IS ALL SYSTEM SECTORS MAPPED ?
	JBE K2				; NO , REPEAT THE PROCESS

	SUB NSECT,SI			; TOTAL SECTORS - BAD SECTOR
	MOV AH,0			
	INT 1AH				; GET RANDOME NUMBER
	MOV WORD PTR SER_NUM+0,DX	; SERIAL NUMBER
	MOV WORD PTR SER_NUM+2,CX
	
	
	DOS2BIOS SECTMAP , S_TRK	; WRITE BOOT SECTOR

	MOV AX,0301H
	MOV DL,PH_DISK
	LEA BX,BOOTCODE
	CALL BIOS13

	LEA DI,TBUFF
	MOV CX,4900
	CLD
	MOV AL,0
	REP STOSB							
	
	MOV SI,RO_T			; WRITE ROOT SECTORS
	MOV CX,14
	
PP1:	PUSH CX
	PUSH SI
	DOS2BIOS [SI] , S_TRK
	LEA BX,TBUFF
	MOV AX,0301H
	MOV DL,PH_DISK
	CALL BIOS13
	POP SI
	ADD SI,2
	POP CX
	LOOP PP1
	
	MOV BYTE PTR TBUFF+0,0F9H	; PREAPERING FAT
	MOV WORD PTR TBUFF+1,0FFFFH
	MOV SI,DA_T
	MOV SI,[SI]
	INC SI
	MOV ST_CLS,2			; STARTING CLUSTURE NUMBER

PP3:	INC ST_CLS			; NEXT CLUSTURE
	CMP BYTE PTR [BMP+SI],0		; IS SECTOR GOOD ?
	JNZ PP5
PP4:	INC SI				; YES , NEXT SECTOR
	CMP SI,NSECT			; IS ALL CHECKED ?
	JB PP3				; NO , REPEAT THE PROCESS
	JMP PPEN

PP5:	MOV BX,ST_CLS			; NO , MARK SECTOR BAD
	SHL BX,1			;  CLUSTUER NUM * 2
	ADD BX,ST_CLS			;  + IT SELF 	= NUM * 3
	SHR BX,1			; NUM /2 = CLUS NUM * 1.5
	JC ODD				; IS ODD NUMBER
	OR WORD PTR [TBUFF+BX],0FF7H	; MARK EVEN CLUSTURE BAD
	JMP PP4				; NEXT SECTOR
ODD:	OR WORD PTR [TBUFF+BX],0FF70H	; MARK ODD  CLUSTURE BAD
	JMP PP4				; NEXT SECTOR

PPEN:   
	LEA SI,SECTMAP
	ADD SI,2			; ADDRES OF 1ST SECTOR FAT 1
	MOV CX,S_FAT			; NUM OF FAT SECTORS
	LEA BX,TBUFF			; IMAGE OF FAT
	
FP1:	PUSH CX				; WRITING FAT 1 SECTORS
	PUSH SI
	PUSH BX
	DOS2BIOS [SI]	, S_TRK
	MOV AX,0301H
	MOV DL,PH_DISK
	POP BX
	PUSH BX
	CALL BIOS13
	POP BX
	ADD BX,512
	POP SI
	ADD SI,2
	POP CX
	LOOP FP1

	;LEA SI,F21
	MOV CX,S_FAT
	LEA BX,TBUFF
	
FP2:	PUSH CX			;      WRITING FAT 2  SECTORS
	PUSH SI
	PUSH BX
	DOS2BIOS [SI]	, S_TRK
	MOV AX,0301H
	MOV DL,PH_DISK
	POP BX
	PUSH BX
	CALL BIOS13
	POP BX
	ADD BX,512
	POP SI
	ADD SI,2
	POP CX
	LOOP FP2

			; WRITING DUMMY BOOT SECTOR, MAY BE FAIL
	MOV RTY1,3
NKN1:	LEA BX,D_B_CODE
	MOV CX,1
	XOR DX,DX
	MOV DL,PH_DISK
	MOV AX,0301H
	CALL BIOS13
	JNC NKN2
	DEC RTY1
	CMP RTY1,0
	JNZ NKN1	
NKN2:

	PRINTF  NL ,'   DISK IS PREPEARED FOR FISA FORMAT.',NL,EL
FSA_E:	RET

FISA_FORMAT ENDP

; DOS LOGICAL DISK FORMAT 
DOS_FORMAT PROC 

	MOV WORD PTR OLD_STACK+0,SP
	MOV WORD PTR OLD_STACK+2,SS

	PUSH CS
	PUSH CS
	POP  DS
	POP  ES

	.IF     SPACE1 == 0
	    MOV D_DIRS    ,112 
	    MOV D_NSECT   ,1440  
	    MOV D_S_FAT	  ,5
	    MOV D_S_TRK	  ,9
	    MOV DA_T      ,18
	.ELSEIF SPACE1 == 1
	    MOV D_DIRS    ,224 
	    MOV D_NSECT   ,2400  
	    MOV D_S_FAT	  ,7
	    MOV D_S_TRK	  ,15
	    MOV DA_T      ,29
	.ELSE 
	    MOV D_DIRS    ,224 
	    MOV D_NSECT   ,2880  
	    MOV D_S_FAT	  ,9
	    MOV D_S_TRK	  ,18
	    MOV DA_T      ,33
	.ENDIF

	MOV D_RATIO  ,1
	MOV D_NBOOT  ,1
	MOV D_NFAT   ,2
	MOV D_MEDIA  ,0F9H
	MOV D_HEAD   ,2

	MOV AH,0			
	INT 1AH				; GET RANDOME NUMBER
	MOV WORD PTR D_SER_NUM+0,DX	; SERIAL NUMBER
	MOV WORD PTR D_SER_NUM+2,CX


	DOS2BIOS 0 , D_S_TRK		; WRITE BOOT SECTOR
	MOV AX,0301H
	MOV DL,PH_DISK
	LEA BX,D_B_CODE
	CALL BIOS13

	LEA DI,TBUFF
	MOV CX,4900
	CLD
	MOV AL,0
	REP STOSB							
	
	MOV SI,1			; WRITE FAT & ROOT SECTORS
	MOV CX,33
	
XPP1:	PUSH CX
	PUSH SI
	DOS2BIOS SI	, D_S_TRK
	LEA BX,TBUFF
	MOV AX,0301H
	MOV DL,PH_DISK
	CALL BIOS13
	POP SI
	INC SI
	POP CX
	LOOP XPP1
	
	MOV BYTE PTR TBUFF+0,0F9H	; PREAPERING FAT
	MOV WORD PTR TBUFF+1,0FFFFH
	MOV SI,DA_T
	MOV ST_CLS,1			; STARTING CLUSTURE NUMBER

XPP3:	INC ST_CLS			; NEXT CLUSTURE
	CMP BYTE PTR [BMP+SI],0		; IS SECTOR GOOD ?
	JNZ XPP5
XPP4:	INC SI				; YES , NEXT SECTOR
	CMP SI,D_NSECT			; IS ALL CHECKED ?
	JB  XPP3			; NO , REPEAT THE PROCESS
	JMP XPPEN

XPP5:	MOV BX,ST_CLS			; NO , MARK SECTOR BAD
	SHL BX,1			;  CLUSTUER NUM * 2
	ADD BX,ST_CLS			;  + IT SELF 	= NUM * 3
	SHR BX,1			; NUM /2 = CLUS NUM * 1.5
	JC  XODD			; IS ODD NUMBER
	OR  WORD PTR [TBUFF+BX],0FF7H	; MARK EVEN CLUSTURE BAD
	JMP XPP4			; NEXT SECTOR
XODD:	OR WORD PTR [TBUFF+BX],0FF70H	; MARK ODD  CLUSTURE BAD
	JMP XPP4				; NEXT SECTOR

XPPEN:  MOV SI,1 
	MOV CX,D_S_FAT			; NUM OF FAT SECTORS
	LEA BX,TBUFF			; IMAGE OF FAT
	
XFP1:	PUSH CX				; WRITING FAT 1 SECTORS
	PUSH SI
	PUSH BX
	DOS2BIOS SI	, D_S_TRK
	MOV AX,0301H
	MOV DL,PH_DISK
	POP BX
	PUSH BX
	CALL BIOS13
	POP BX
	ADD BX,512
	POP SI
	INC SI
	POP CX
	LOOP XFP1

	MOV CX,D_S_FAT
	LEA BX,TBUFF
	
XFP2:	PUSH CX			;      WRITING FAT 2  SECTORS
	PUSH SI
	PUSH BX
	DOS2BIOS SI	, D_S_TRK
	MOV AX,0301H
	MOV DL,PH_DISK
	POP BX
	PUSH BX
	CALL BIOS13
	POP BX
	ADD BX,512
	POP SI
	INC SI
	POP CX
	LOOP XFP2

	PRINTF  NL ,'   DISK IS PREPEARED FOR DOS FORMAT.',NL,EL
	RET

DOS_FORMAT ENDP

CODE_SEG ENDS
; BOOT SECTORS  
	INCLUDE DOS_BOOT.INC
	INCLUDE FSA_BOOT.INC
	


; UN INITILIZED MEM SPACE 
BITMAP SEGMENT 'BSS'
	BMP LABEL BYTE
	DB 3000 DUP (?)
	TBUFF LABEL BYTE
	DB 11000 DUP (?)	; BUFFER FOR MORE THAN 18 SECT = [9,216]	
BITMAP ENDS




END MAIN
	



