

	CON_COL	EQU 50H
	NL EQU 13,10
	EL EQU 0
;
PRINTF MACRO  MSG__:VARARG
LOCAL   NAME__
	DATA_SEGS SEGMENT WORD PUBLIC 'DATA'
	  NAME__ LABEL BYTE
	  DB MSG__
	DATA_SEGS ENDS
	INVOKE TOCON, OFFSET DGROUP:NAME__
ENDM
;

OUTXY   PROTO  C X:BYTE , Y:BYTE , MSG__:WORD
PUTXY   PROTO  C X:BYTE , Y:BYTE , CHAR:BYTE , ATTR:BYTE
WINDOW  PROTO C X1:BYTE , Y1:BYTE , X2:BYTE , Y2:BYTE
WIN_CLS PROTO C
TOCON   PROTO C MSG__:WORD
PUTCHAR PROTO C CHAR:BYTE


OUTXY PROC C X:BYTE , Y:BYTE , MSG__:WORD
	PUSHA
	MOV SI,MSG__
	MOV CL,X
	 .WHILE ( BYTE PTR [SI] != 0 )
	    INVOKE PUTXY , CL , Y , BYTE PTR [SI],0
	    INC SI
	    INC CL
	 .ENDW
	POPA
	RET
OUTXY ENDP

PUTXY PROC C X:BYTE , Y:BYTE , CHAR:BYTE , ATTR:BYTE
	PUSHA

	MOV BX,0B800H
	MOV ES,BX
	
	MOV AX,160
	XOR BX,BX
	MOV BL,Y
	MUL BL
	MOV BL,X
	SHL BX,1
	ADD BX,AX
	MOV AH,ATTR
	MOV AL,CHAR
	.IF  AH!=0
		MOV ES:[BX],AX
	.ELSE
		MOV ES:[BX],AL
	.ENDIF
	POPA
	RET
PUTXY ENDP


WINDOW PROC C X1:BYTE , Y1:BYTE , X2:BYTE , Y2:BYTE
	PUSH AX
	PUSH BX
	MOV AH,X1
	MOV AL,X2
	MOV BH,Y1
	MOV BL,Y2
	MOV LEFT,AH
	MOV TOP,BH
	MOV RIGHT,AL
	MOV BOTTOM,BL
	MOV ROW,BH
	MOV COL,AH
	POP BX
	POP AX
	RET
WINDOW ENDP

WIN_CLS PROC C
    PUSHA

    MOV AH,TOP
    MOV AL,LEFT
    MOV ROW,AH
    MOV COL,AL
    MOV CL,BOTTOM
    INC CL
    SUB CL,TOP

     MOV AH,6
     MOV AL,CL
     MOV BH,CON_COL
     MOV CH,TOP
     MOV CL,LEFT
     MOV DH,BOTTOM
     MOV DL,RIGHT	
     INT 10H
     MOV AH,TOP
     MOV AL,LEFT
     MOV ROW,AH
     MOV COL,AL
     
     POPA
     RET
WIN_CLS ENDP

TOCON PROC C MSG__:WORD
      PUSHA
      MOV SI,MSG__
      .WHILE (BYTE PTR [SI] != 0)
	INVOKE PUTCHAR , BYTE PTR [SI]
	INC SI
      .ENDW
     POPA
     RET
TOCON ENDP

PUTCHAR PROC C CHAR:BYTE
  PUSHA
  MOV AH,ROW
  MOV AL,COL
  .IF  CHAR==10
     .IF AH < BOTTOM
	INC ROW
	POPA
	RET
     .ENDIF
     MOV AH,6
     MOV AL,1
     MOV BH,CON_COL
     MOV CH,TOP
     MOV CL,LEFT
     MOV DH,BOTTOM
     MOV DL,RIGHT
     INT 10H
     POPA
     RET
  .ELSEIF CHAR==13
     MOV AH,LEFT
     MOV COL,AH
     POPA
     RET
  .ELSEIF AL > RIGHT
     INVOKE PUTCHAR , 10
     MOV AH,LEFT
     MOV COL,AH
  .ENDIF

  MOV AX,0B800H
  MOV ES,AX
  XOR BX,BX
  MOV AX,160
  MOV BL,ROW
  MUL BL
  MOV BL,COL
  SHL BX,1
  ADD BX,AX
  MOV AL,CHAR
  MOV ES:[BX],AL
  INC COL
  POPA
  RET	
PUTCHAR ENDP



MEDIA_TYPE PROC
	MOV AL,L_MEDIA
	INC AL
	CMP AL,3
	JB MED00
	XOR AL,AL
MED00:  MOV L_MEDIA,AL
	.IF 	  AL==0
	  	     INVOKE OUTXY, 50 , 4 , OFFSET FISA_M
	.ELSEIF   AL==1
	  	     INVOKE OUTXY, 50 , 4 , OFFSET DOS_M
	.ELSEIF   AL==2
	  	     INVOKE OUTXY, 50 , 4 , OFFSET A_UTO
	.ENDIF
	RET
MEDIA_TYPE ENDP

DISK_TYPE PROC
	MOV AL,SPACE1
	INC AL
	CMP AL,4
	JB SPD00
	XOR AL,AL
SPD00:  MOV SPACE1,AL
	.IF       AL==0
	  	     INVOKE OUTXY, 28 , 4 , OFFSET D720
	.ELSEIF   AL==1
	  	     INVOKE OUTXY, 28 , 4 , OFFSET D120
	.ELSEIF   AL==2
	  	     INVOKE OUTXY, 28 , 4 , OFFSET D144
	.ELSEIF   AL==3
	  	     INVOKE OUTXY, 28 , 4 , OFFSET A_UTO
	.ENDIF
	RET
DISK_TYPE ENDP

PHYS_DRV PROC
	MOV AL,PH_DISK
	INC AL
	CMP AL,2
	JB PHY00
	XOR AL,AL
PHY00:	MOV PH_DISK,AL
	MOV CL,AL
	ADD CL,'A'
	INVOKE PUTXY, 13 ,4 , CL ,0
	RET
PHYS_DRV ENDP



HELP PROC C 
	 PUSHA
	 CALL WIN_CLS
	 PRINTF NL,' * Options Toggle By Pressing Letter',EL
	 PRINTF NL,' * Select Physical Drive Lettre ',EL
	 PRINTF NL,' * Select Disk Type 720KB, 1.2MB, 1.44MB , Auto ',EL
	 PRINTF NL,' * Select Source Logical Format  Fisa , Dos , Auto ',EL
	 PRINTF NL,NL,'       Press Escape to Exit ',EL
	 PRINTF    NL,'       Press Enter To Go    ',EL
	 POPA
	 RET
HELP ENDP


OUT_INT PROC C X:BYTE , Y:BYTE , CHAR:BYTE
	PUSHA
	XOR AX,AX
	MOV AL,CHAR
	AAM	
	OR AX,3030H
	MOV BX,AX
	INVOKE PUTXY , X , Y   , BH, 0
	MOV BH,X
	INC BH
	INVOKE PUTXY , BH , Y , BL,0
	POPA
	RET
OUT_INT ENDP

EXTRN LAYOUT:BYTE

LOADSCR PROC
	PUSH DS
	MOV AX,3
	INT 10H
	MOV SI,SEG LAYOUT
	MOV DS,SI
	LEA SI,LAYOUT
	XOR DI,DI
	MOV CX,4000
	CLD
	MOV AX,0B800H
	MOV ES,AX
	REP MOVSB
	POP DS 
	INVOKE WINDOW ,5,6,72,20
	CALL WIN_CLS
	RET
LOADSCR ENDP


