

;
; SEARCH & LOAD THE BOOT SECTOR OF BAD FLOPPY 
;
LOAD_SECTMAP PROC
	PUSH CS
	PUSH CS
	POP  DS
	POP  ES
	MOV DSK_BOOT,9		; ASSUME 9TH  ONE IS BOOT SECTOR

BB1:	DOS2BIOS DSK_BOOT , 18	; CONVERT LOGICAL SECTOR TO TRK+HEAD+SECT
	LEA BX,BOOT_BUFF	; LOACAL BOOT SECTOR BUFFER 
	MOV AX,0201H		; ASSUMING 1.44 DISK BUT IT MAY NOT
	MOV DL,CS:PH_DISK
	INT 13H
	JNC BB4
	CMP AH,06H
	JZ BB1
	CMP AH,02H
	JZ BB3
	CMP AH,04H
	JZ BB3
	CMP AH,10H
	JZ BB3
	RET
		
BB4:	LEA BX,BOOT_BUFF
	LEA SI,DGROUP:SGN_STR		; IS BOOT HAS SIGNATURE STRINGS
	LEA DI,BOOTS:SGN_STR
	ADD DI,BX
	MOV CX,SGN_LEN
	CLD
	REPE CMPSB
	JZ BB2
	
BB3:	INC DSK_BOOT			; MAY BE NEXT SECT WILL BE BOOT
	CMP DSK_BOOT,72			; IS SEARCH COMES TO SECT # 72
	JBE BB1				; ONLY 72 BECAUSE OF PERFORMANCE
	RET				; BUT CAN BE INCREASE

BB2:	MOV CS:IS_VALID_BUFF,55H	; FOUND VALID BOOT SECTOR
					; SET IS_VALID_BUFF TO TRUE (!0)
					; NOW LOCAL BOOT BUFF CONTAINIG
					; VALID BPB & SECTOR MAP
	LEA BX,BOOT_BUFF
	LEA SI,BOOTS:S_TRK
	MOV AX,[SI + BX ]
	MOV S_TRK,AX			; SAVE IT TO IDLE BOOT SECTOR
	LEA SI,BOOTS:DIRS
	MOV AX,[SI  + BX]		; DIR  ENTRIES	
	MOV CL,4			; NUMBER SECTOR REQUIRED
	SHR AX,CL			; ENTRIES / 16 = SECTORS
	LEA SI,BOOTS:S_FAT
	ADD AX,[SI + BX]		; ADD TO AX  ( FAT1 SECTORS )
	ADD AX,[SI + BX]		; ADD TO AX  ( FAT2 SECTORS )
	INC AX				; AX= TOTAL SYSTEM SECTORS
	MOV SYS_SECT,AX			; SAVE IT TO IDLE BOOT SECTOR
	RET
	
LOAD_SECTMAP ENDP

