DGROUP GROUP BOOTS

; BOOT RECORD OF DISK 
BOOTS SEGMENT 'CODE'

BOOTCODE:	JMP BCODE
		NOP
ORG 3
OEM		DB 'NON DOS.'
NBYTES 		DW  512			; BYTES PER SECTOR
RATIO		DB  1			; SECTOR PER CLUSTER
NBOOT	 	DW  1			; NUMBER OF BOOT SECTOR
NFAT  		DB  2			; NUMBER OF FATS
DIRS 	 	DW  224			; NUMBER ROOT DIR ENTRIES
NSECT 		DW  2880		; TOTAL NUMBER OF SECTOR
MEDIA 		DB  0F9H		; MEDIA DESCRIPTION BYTE
S_FAT 		DW  9			; NUMBER OF SECTOR PER FAT
S_TRK 		DW  18			; SECTOR PER TRACK
HEAD  		DW  2			; NUMBER OF HEADS
		DW  0
		DW  0		
		DD  0
		DW  0
		DB  0
SER_NUM		DD  0			;SER NO
VOL_ID 		DB 'FISA [DISK]'
		DB 'FAT12   '
BCODE:	
	XOR	CX,CX                              
	MOV	SS,CX                              
	MOV	SP,7BFCH                            
	PUSH	SS                                 
	POP	ES                                 
	PUSH	SS
	POP	DS
	MOV	AX,0010H
	INT 	10H
	LEA	SI,BOOTS:MSG + 7C00H 
BC1:	MOV BX,14
	MOV AH,0EH
	MOV AL,[SI]
	INT 10H
	INC SI
	CMP AL,0
	JNZ BC1
	MOV AH,0
	INT 16H
	mov ax,3
	int 10h
	INT 19H
MSG	DB 13,10,'NON-DOS DISK. PRESS ANY KEY TO BOOT.'
	DB 13,10,0
	
DB 0
ORG 0A0H
SGN_STR	DB 'THIS DISK CAN ONLY BE ACCESS BY ASIF`s DEVICE DRIVER.',0
	DB 'YOU CAN OBTAIN THE DRIVER FROM FASTICS KARACHI.',0
	DB 'DO NOT ALTER THE STRINGS.',0
	DB 'SAY YES, TO BAD FLOPPY DISK.',0
	DB 'SAY BE HAPPY, TO DOS.',0
	DB 'SAY NICE, TO ASIF KHAN SURI.',0
SGN_LEN = $ - SGN_STR - 2



DB 0
ORG 190H
	; BELOW IS THE WORD BITMAP  FOR THE LOACTION OF BOOT SECTOR 
	; , FATS SECTORS , ROOT SECTORS AND 1ST DATA SECTOR
	; WHERE WORD REPSENT THE ABSOLUTE SECTOR NUMBER ( O BASE).

	SECTMAP	LABEL WORD
	DW 40 DUP (0)

DB 0	
ORG 508
	CHK_SUM	DW	?		; CHK_SUM WORD
	DB 055H, 0AAH
			
BOOTS ENDS

; SECTOR BUFFER FOR IMAGE TRANSFER 


