DGROUP GROUP DOS_BOOTS

; BOOT RECORD OF DISK 
DOS_BOOTS SEGMENT 'CODE'

D_B_CODE:	JMP DBCODE_
		NOP
ORG 3
		DB 'FISADISK'
		DW  512		; BYTES PER SECTOR
D_RATIO		DB  1		; SECTOR PER CLUSTER
D_NBOOT		DW  1		; NUMBER OF BOOT SECTOR
D_NFAT		DB  1		; NUMBER OF FATS
D_DIRS		DW  16		; NUMBER ROOT DIR ENTRIES
D_NSECT		DW  8		; TOTAL NUMBER OF SECTOR
D_MEDIA		DB  0FCH	; MEDIA DESCRIPTION BYTE ( S SIDED 9 SECT)
D_S_FAT		DW  1		; NUMBER OF SECTOR PER FAT
D_S_TRK		DW  9		; SECTOR PER TRACK
D_HEAD		DW  2		; NUMBER OF HEADS
		DW 0
		DW 0		
		DD 8
		DW 0
		DB 0
D_SER_NUM	DD 0101
		DB 'DUMMY..DISK'
		DB 'FAT12   '
DBCODE_:	
	XOR	CX,CX                              
	MOV	SS,CX                              
	MOV	SP,7BFCH                            
	PUSH	SS                                 
	POP	ES                                 
	PUSH	SS
	POP	DS
	MOV	AX,0010H
	INT 	10H
	LEA	SI,DOS_BOOTS:XSG 
	ADD	SI,7C00H 
XC1:	MOV BX,14
	MOV AH,0EH
	MOV AL,[SI]
	INT 10H
	INC SI
	CMP AL,0
	JNZ XC1
	MOV AH,0
	INT 16H
	mov ax,3
	int 10h
	INT 19H
XSG	DB 13,10,'DISK IS FORMATED BY FISA DISK FORMATTER { by Asif Khan Suri }.'
	DB 13,10,'DISK MAY BE BAD , AND ONLY ACCESS BY FISA DISK DRIVER,'
	DB 13,10,'        YOU CANNOT BOOT FROM THIS DISK.'
	DB 13,10,'  REMOVE THE FLOPPY AND PRESS ANY KEY TO BOOT.'
	DB 13,10,0


ORG 510 
DB 055H , 0AAH
DOS_BOOTS ENDS

; SECTOR BUFFER FOR IMAGE TRANSFER 

			


