
BOOT_REC    STRUCT		; 11 BYTES ARE RESERVE AT START
_NBYTES		DW  ?		; BYTES PER SECTOR
_RATIO		DB  ?		; SECTOR PER CLUSTER
_NBOOT		DW  ?		; NUMBER OF BOOT SECTOR
_NFAT		DB  ?		; NUMBER OF FATS
_DIRS		DW  ?		; NUMBER ROOT DIR ENTRIES
_NSECT		DW  ?		; TOTAL NUMBER OF SECTOR
_MEDIA		DB  ?		; MEDIA DESCRIPTION BYTE ( S SIDED 9 SECT)
_S_FAT		DW  ?		; NUMBER OF SECTOR PER FAT
_S_TRK		DW  ?		; SECTOR PER TRACK
_HEAD		DW  ?		; NUMBER OF HEADS
BOOT_REC ENDS			


READ_BPB PROC 
	




	; GET MAP WILL SEARCH WHOLE THE DISK
	; AND RETURN INFORMATION ABOUT EACH SECTOR IN THE BYTE MAP (BMP)
	;            0 = SECTOR NEVER USED
	;	     1 = SECTOR MAY BE USED
	;	     2 = SECTOR IS BAD
	; ALL VARIABLES ARE GLOBLE	
	; FURTHER MORE, WITH THE HELP OF FAT , HIGH BIT WILL BE SET 
	; IF SECTPOR IS USE BY ANY FILE OR TREE CLUSTURE

GETMAP  PROC 

	PUSHA
	
	XOR CX,CX
	LEA SI,BMP

	PUSH DS
	POP ES	

.WHILE ( CX <= T_SECT )		
	PUSH CX
	PUSH SI
	
	DOS2BIOS CX , SECT_TRK
	MOV DL,PH_DISK
	LEA BX,TBUFF
	MOV AX,0201H
	CALL BIOS13
	.IF CARRY?
	   POP SI
	   MOV BYTE PTR [SI],2
	.ELSE   
 	  LEA SI,BYTE_F6
	  CLD
	  MOV CX,500
	  LEA DI,TBUFF
	  REPE CMPSB
	  .IF ZERO?
	     POP SI
	     MOV BYTE PTR [SI],0
	  .ELSE
	     POP SI
	     MOV BYTE PTR [SI],1
	  .ENDIF
	.ENDIF 
	INC SI
	POP CX
	INC CX
.ENDW

	POPA
	RET

GETMAP ENDP


GET_DOS_BPB_MAP
	DOS2BIOS 0 , 9
	MOV DL,PH_DISK
	LEA BX,TBUFF
	MOV AX,0201H
	CALL BIOS13
	.IF !CARRY?
	   LEA SI,TBUFF+11
	   LEA DI,DOS_BPB
	   MOV CX,(SIZEOF BOOT_REC)+2
	   CLD
	   REP MOVSB
	.ELSE
	   ;PRTINTF _?_,NL,'ENTER DISK TYPE  [ 0=720 ,1=1.2 ,2=1.44 ]  ',EL
	   ; CALL SOME FUNCTION WHICH RETURN TYPE IN [DISK VARIABLE]
	   .IF      DISK == 0
	            LEA SI,D720_BPB
	   .ELSEIF DISK == 1
	            LEA SI,D120_BPB
	   .ELSE
	            LEA SI,D144_BPB
	   .ENDIF
	   LEA DI,DOS_BPB
	   MOV CX,(SIZEOF BOOT_REC)+2
	   CLD
	   REP MOVSB
	.ENDIF 
	LEA SI,DOS_BPB	
	LEA BX,FAT
	
	
	DOS2BIOS CX , [SI]._S_TRK
	MOV DL,PH_DISK
	MOV AX,0201H
	CALL BIOS13
	.IF CARRY?
	   POP CX
	   POP SI
	   PUSH SI
	   PUSH CX
	   ADD CX,[SI]._S_FAT	
	   DOS2BIOS CX , [SI]._S_TRK
	   MOV DL,PH_DISK
	   MOV AX,0201H
	   CALL 
	
	   		    
	  



